import tornado
from tornado.escape import json_encode
import requests, json

from base import controller
from models.dbQuery import db_query
from settings import STORAGE_URL

UPLOAD_PATH = STORAGE_URL + 'upload'


class Inventory(controller.Controller):
    # @tornado.web.authenticated
    def get(self):
        data = {}

        inventory = requests.get(STORAGE_URL + 'storage/inventory.map')
        inventory = inventory.json() if inventory.ok else False
        data["inventory"] = inventory
        data["action"] = "inventory"

        self.render("inventory.html", data=data)

    def post(self):
        data = {'path': "/", 'nohash': 1, 'force': 1}

        fdata = {"file": ("inventory.map", self.args["inventory"])}
        r = requests.post(UPLOAD_PATH, data=data, files=fdata)
        self.redirect("/inventory")
