from base import controller

class Login(controller.Controller):

    def get(self):

        if self.current_user:
            self.redirect('/')
            return

        self.render("login.html", email = self.get_argument("email", ""), next=self.get_argument("next", "/"))


    def post(self):

        if self.args_required(["email", "password"]):

            mail = self.args["email"]
            passw = self.args["password"]

            user = self.user_model.auth_user(mail, passw)
            if user:
                secret = self.crypt_string(mail, self.user_model.secret)
                self.set_secure_cookie("secret", secret)
                self.redirect(self.get_argument("next", "/"))
            else:
                self.render("login.html", email = mail)
        else:
            self.render("login.html", email = self.get_argument("email", ""))



