from base import controller
from models.dbQuery import db_query
import requests, json
from random import randrange

import trimesh
import copy
import numpy as np

from settings import STORAGE_URL

from controllers.block import MANIFEST_TEMP
from controllers.view import UPLOAD_PATH 
from controllers.view import compute_cels

class UserBlockNew(controller.Controller):

    def get(self):

        self.render("user_block_new.html")


    def post(self):

        children = []
        obj_path = ''

        data = copy.deepcopy(MANIFEST_TEMP)
        data["_id"] = str(randrange(0, 1<<63))
        data["manifest"]["meta"]["id"] = str(data["_id"])

        # save assets
        file = self.request.files["asset"][0]

        files_data = {"file": (file["filename"], file["body"], file["content_type"])}
        r = requests.post(UPLOAD_PATH, data={'path': "avvy_assets"}, files=files_data)

        filename = r.json()["files"]["file"]
        obj_path = STORAGE_URL + "storage/" + filename

        print(obj_path)

        children = compute_cels(obj_path)
        data["manifest"]["properties"]["children"] = children
        data["manifest"]["meta"]["views"]["0"] = obj_path
        data["manifest"]["meta"]["name"] = self.args.pop("name")
        data["manifest"]["meta"]["description"] = self.args.pop("desc")
        data["manifest"]["meta"]["tags"] = self.args.pop("tags")

        # data["draft"] = True
        db_query.add_block(data)

        self.write(json.dumps({'data': data}))
