from pymongo import MongoClient
from bson import ObjectId
import uuid
import redis
import json
from datetime import datetime
from tornado import escape

client = MongoClient()

class DBQuery:

    redis = redis.Redis()
    mongo = client['blocks_admin']

    def set_secret(self, secret):
        if self.redis.get('AvvyAuthSecret'):
            return
        self.redis.set('AvvyAuthSecret', secret)

    def get_secret(self):
        return self.redis.get('AvvyAuthSecret').decode()

    def get_admins(self):
        pass

        # db_users = self.redis.keys("AvvyAdmin:*")

        # users = {}

        # for key in db_users:
        #     key = key.decode()
        #     user = key.split(":")
        #     access = self.redis.get(key)

        #     users[user[1]] = {"passw": user[2], "secret": str(
        #         uuid.uuid4()), "access": int(access)}

        # return users

    def add_block(self, data):
        data["manifest"]["meta"]["tags"] = data["manifest"]["meta"]["tags"].split(",")
        self.mongo.blocks.save(data)
        return data

    def get_blocks(self):
        data = self.mongo.blocks.find({})
        return data

    def get_block(self, bclass = "new"):
        data = self.mongo.blocks.find_one({"_id": bclass})
        if data:
            data["manifest"]["meta"]["tags"] = ",".join(data["manifest"]["meta"]["tags"]).replace(' ', '')
        return data

    def delete_block(self, bclass):
        self.mongo.blocks.delete_one({"_id": bclass})

    def delete_category(self, cid):
        self.mongo.categories.delete_one({"_id": cid})


db_query = DBQuery()
db_query.set_secret(str(uuid.uuid4()))
