(function ($) {
    "use strict";
  
    window.AvvY = window.AvvY || {};
  
    window.AvvY.createRequest = function (params) {
      var method = params.method || "GET";
      var url = params.url || null;
      var data = params.data || {};
      var onSuccess = params.onSuccess || null;
      var onError = params.onError || null;
  
      data._xsrf = $("input[name='_xsrf']").val();
  
      if (url) {
        $.ajax({
          method: method,
          url: url,
          data: data,
        })
          .done(function (msg) {
            msg = msg && window.AvvY.isJson(msg) ? JSON.parse(msg) : msg;
            if (msg && msg.error) {
              onError(msg);
              return;
            }
            if (msg && msg.redirect) {
              window.location = msg.redirect;
              return;
            }
            if (onSuccess) onSuccess(msg);
          })
          .fail(function () {
            onError();
          });
      }
    };
  
    window.AvvY.isJson = function (str) {
      try {
        JSON.parse(str);
      } catch (e) {
        return false;
      }
      return true;
    };
})(jQuery)